####### filedir
shdir=`dirname $0`
bindir=/usr/local/gzsa/safecontrol
libdir="$bindir"
datadir="$bindir"/../data
cfgdir="$bindir"/../data/cfg
logdir="$bindir"/../data/log
vardir="$bindir"/../data/var
kover=`uname -r|awk -F- '{print $1}'`
fwlcmd=0 #ǽ
upmode=0 #ģʽ

initdir=/etc/init.d
initdir0=/etc/rc0.d
initdir1=/etc/rc1.d
initdir2=/etc/rc2.d
initdir3=/etc/rc3.d
initdir4=/etc/rc4.d
initdir5=/etc/rc5.d
initdir6=/etc/rc6.d
linkdir=/usr/share/applications

####### binfile
cltsvr=cltsvr
clttray=clttray
cltdev=cltdev
cltfw=cltfw
cltaudit=cltaudit
secpag=secpag
cltfmon=cltfmon
cltfchk=cltfchk

####### linkfile
clttray_link=gzsa_clttray.desktop
uninstall_link=gzsa_uninstall.desktop

####### config
cltsvrd=cltsvrd
secpagd=secpagd
install=init.ini
policy=policy.bjs
syscfg=syscfg.bjs

forcemv()
{
  if [ -f "$1" ] ; then
    mv -f "$1" "$2"
    chmod 777 "$2"
  fi
}

setinitd()
{
  chattr -i "$initdir"/"$1"
  forcemv "$bindir"/"$1" "$initdir"/"$1"
  chattr +i "$initdir"/"$1"
  ln -sf  "$initdir"/"$1" "$initdir3"/S98"$1"
  ln -sf  "$initdir"/"$1" "$initdir4"/S98"$1"
  ln -sf  "$initdir"/"$1" "$initdir5"/S98"$1"
}

runinitd()
{
  count=`ps -ef |grep "$cltsvr -r" |grep -v "grep" |wc -l`
  if [ $count -eq 0 ]; then
    service "$1" start
	sleep 0.5
  fi
  count=`ps -ef |grep "$cltsvr -r" |grep -v "grep" |wc -l`
  if [ $count -eq 0 ]; then
    "$initdir"/"$1" start
	sleep 0.5
  fi
}

mvdirfile()
{
  if [ -d "$1" ] ; then
    if [ ! -d "$2" ] ; then
      echo  mkdir "$2"
      mkdir "$2"
    fi
    for file in ` ls $1`
    do
      if [ -d "$1"/"$file" ] ; then
        mvdirfile "$1"/"$file" "$2"/"$file"
      else
        forcemv "$1"/"$file" "$2"/"$file"
      fi
    done
  fi
}

# ж
command -v firewall-cmd >/dev/null 2>&1 || { fwlcmd=1; }

# жϰװ
upmode=`grep -c update $shdir/init.ini`

####### Install
if [ ! -d "$initdir" ] ; then
initdir=/etc/rc.d/init.d
initdir0=/etc/rc.d/rc0.d
initdir1=/etc/rc.d/rc1.d
initdir2=/etc/rc.d/rc2.d
initdir3=/etc/rc.d/rc3.d
initdir4=/etc/rc.d/rc4.d
initdir5=/etc/rc.d/rc5.d
initdir6=/etc/rc.d/rc6.d
fi

"$bindir"/"$cltsvr" -s
"$bindir"/"$cltfmon" -s
"$bindir"/"$cltfchk" -s

killall "$cltsvr"
killall "$cltdev"
#killall "$secpag" #ģ鲻ֹͣ
killall "$clttray"
killall "$cltfmon"
killall "$cltfchk"
killall "$cltfw"
killall "$cltaudit"
rmmod   "$cltfw"

# ȥĿ¼
chattr -R -i "$bindir"

if [ $upmode -eq 0 ];then
rm -rf "$bindir"/*
fi

#install dir
if [ ! -d "$libdir" ] ; then
mkdir -p "$libdir"
fi

if [ ! -d "$bindir" ] ; then
mkdir -p "$bindir"
fi

if [ ! -d "$datadir" ] ; then
mkdir -p "$datadir"
fi

if [ ! -d "$cfgdir" ] ; then
mkdir -p "$cfgdir"
fi

if [ ! -d "$logdir" ] ; then
mkdir -p "$logdir"
fi

if [ ! -d "$vardir" ] ; then
mkdir -p "$vardir"
fi

# װ֤
if [ -d "$shdir"/usbkey/ ] ; then
  "$shdir"/usbkey/install.sh install
  rm -rf "$shdir"/usbkey
fi

# Ŀ¼ļ
mvdirfile "$shdir" "$bindir"
forcemv "$bindir"/ko/"$cltfw"-"$kover".ko "$bindir"/"$cltfw".ko
forcemv "$bindir"/ko/"$cltfw" "$bindir"/"$cltfw"

rm -rf "$bindir"/ko
rm -f "$bindir"/shell.sh
rm -f "$bindir"/qt563/InstallerView
rm -f "$bindir"/InstallerView.sh
rm -f "$bindir"/detail.json

# install init
forcemv "$bindir"/"$install" "$vardir"/"$install"
forcemv "$bindir"/"$syscfg" "$vardir"/"$syscfg"
forcemv "$bindir"/"$policy" "$cfgdir"/"$policy"

# install link
forcemv "$bindir"/"$clttray_link" "$linkdir"/"$clttray_link"
forcemv "$bindir"/"$uninstall_link" "$linkdir"/"$uninstall_link"

setinitd "$cltsvrd"
setinitd "$secpagd"
systemctl daemon-reload
sleep 0.5
# ˿ڿ
enablePort()
{
if [ "$fwlcmd" -eq 0 ]; then
  firewall-cmd --zone=public --add-port="$1"/"$2" --permanent
else
  ufw allow "$1"/"$2"
fi
}

# ǽ 5309˿
enablePort 218  tcp
enablePort 5302 tcp
enablePort 5309 udp

# װ
chattr -R +i "$bindir"
chmod -R 777 "$datadir"

# 
echo "start..."
runinitd "$cltsvrd"
sleep 1
runinitd "$cltsvrd"

autopath=/root/.config/autostart
username=`who|awk '{print $1}'|head -n 1`
if [ "$username" != "root" ]; then

	autopath="/home/$username/.config/autostart"
	
fi
uossys=`cat /etc/issue|grep uos|wc -l`
if [ $uossys -ge 1 ];then

	`cp /usr/share/applications/gzsa_clttray.desktop $autopath`
	echo "\nHidden=false" >> $autopath/gzsa_clttray.desktop
fi
#######################
