var MSKF_FIRST = -1;

var MSKF_DISCONNECT_DEV = 0;
var	MSKF_CONNECT_DEV = 1; 
var	MSKF_GET_UKEY_STATUS = 2;

var	MSKF_GET_MANUFACTURER = 10;
var	MSKF_GET_DEV_LABEL= 11;
var	MSKF_GET_SERIAL_NUMBER= 12;
var	MSKF_GET_ERROR_CODE= 13;
var	MSKF_GET_FREE_SPACE= 14;

var	MSKF_INITIALIZE_DEVICE = 20;
var	MSKF_OPEN_APP_CONTAINER = 21;
var	MSKF_OPEN_APPLICATION = 22;
var	MSKF_OPEN_CONTAINER = 23;
var	MSKF_CLOSE_CONTAINER = 24;
var	MSKF_CLOSE_APPLICATION = 25;
var	MSKF_CLOSE_APP_CONTAINER = 26;
var	MSKF_CHANGE_UKEY_PIN = 27;
var	MSKF_VERIFY_UKEY_PIN = 28;
var	MSKF_ENUM_APP = 29;
var	MSKF_ENUM_CONTAINER = 30;

var	MSKF_GEN_KEYPAIR_SM2 = 40;
var	MSKF_GET_PUBLICKEY = 41;
var	MSKF_GET_SIGN_PUBLICKEY = 42;
var	MSKF_GET_ENC_PUBLICKEY = 43;
var	MSKF_WRITE_SIGN_CERT_SM2 = 44;
var	MSKF_SIGN_DATA_SM2 = 45;
var	MSKF_SIGN_PLAIN_SM2 = 46;
var	MSKF_GET_CERT = 47;
var	MSKF_GET_SIGN_CERT = 48;
var	MSKF_GET_ENC_CERT = 49;
var	MSKF_VERIFY_DATA_SM2 = 50;
var	MSKF_VERIFY_PLAIN_SM2 = 51;
var	MSKF_SM2_PKCS7_SIGN_DATA = 52;
var	MSKF_SM2_PKCS7_VERIFY_DATA = 53;
var	MSKF_SM2_ENCRYPT_ENVELOP = 54;
var	MSKF_SM2_DECRYPT_ENVELOP = 55;

var	MSKF_DIGEST = 60; //单组hash

var	MSKF_CREATE_FILE = 70;
var	MSKF_DELETE_FILE = 71;
var	MSKF_ENUM_FILES = 72;
var	MSKF_GET_FILE_INFO = 73;
var	MSKF_READ_FILE = 74;
var	MSKF_WRITE_FILE = 75;

var	MSKF_ENCRYPT = 80; //对称加密
var	MSKF_DECRYPT = 81;      //对称解密
var	MSKF_ECC_ENCRYPT = 82;  //ECC加密
var MSKF_ECC_DECRYPT = 83;  //ECC解密

//var url = "http://192.168.76.169:60000";
var url = "http://127.0.0.1:60000";
//var url = "http://10.30.164.198:60000";

function ajax(opts) {
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function () {
        if (xhr.readyState == 4 && xhr.status == 200) {
            opts.success(xhr.responseText);
        }
        else if (xhr.readyState == 4 && xhr.status != 200) {
            opts.error();
        }
    };

    if (opts.type.toLowerCase() === 'get') {
        xhr.open(opts.type, opts.url, false);
        xhr.send();
    }

    if (opts.type.toLowerCase() === 'post') {
        xhr.open(opts.type, opts.url, false);
        xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        xhr.send(opts.data);
    }
}
var parseParam = function (param, key) {
    var paramStr = "";
    if (param instanceof String || param instanceof Number || param instanceof Boolean) {
        paramStr += "&" + key + "=" + encodeURIComponent(param);
    } else {
        $.each(param, function (i) {
            var k = key == null ? i : key + (param instanceof Array ? "[" + i + "]" : "." + i);
            paramStr += '&' + parseParam(this, k);
        });
    }
    return paramStr.substr(1);
};
function sendData(url, data) 
{
    var json_data = JSON.stringify(data);
    //var json_data = parseParam(data);
    //url = url + "?" + json_data;
    console.log('json_data：' + json_data);
    var content = "";
    $.ajax({
        type: "post",
        url: url,
        data: json_data,
        cache: false,
        async: false,
        dataType: 'text',
        success: function (data) {
            //console.log('返回值：' + data);
            content = data;
        },
        error: function () {
            alert("连接错误");
            return;
        }
    });

    return content;
}
