#!/bin/bash
#this is install usbkeytool and admintool and keyproxy

#echo '----------start install ------------'

#get this shell.sh default path
shell_path=$(cd `dirname $0`; pwd)
cd ${shell_path}
#echo ${shell_path}





#====================================

software_name='software'

usbkey_so_name='libFriDriverKeyE_rls.so'
usbkey_rules_name='81-EsStdKey.rules'


#
install_to_path='/usr/local/usbkey'
#
usbkey_tool_path='usbkeytool'
usbkey_tool_name='usbkeytool'
#
admin_tool_name='admintool'
admin_tool_path='admintool'
#
keyproxy_name='KeyProxy'
keyproxy_path='KeyProxy'
#
FriDriverUI_name='FriDriverUIPackage'
FriDriverUI_path='FriDriverUIPackage'

keyproxy_html_path='html'



#
function install_uk_so()
{
	if [ -e	 "/usr/lib/${usbkey_so_name}" ]; then
		sudo rm -r -f /usr/lib/${usbkey_so_name}
	fi
	sudo cp -f ${shell_path}/${software_name}/${usbkey_so_name}  /usr/lib
	echo "UKEY's lib install OK"
	
	if [ -e	 "/etc/udev/rules.d/${usbkey_rules_name}" ]; then
		sudo rm -r -f /etc/udev/rules.d/${usbkey_rules_name}
	fi
	sudo cp -f ${shell_path}/${software_name}/${usbkey_rules_name}  /etc/udev/rules.d
	echo "UKEY's rudes install OK"
}

function uninstall_uk_so()
{
	if [ -e	 "/usr/lib/${usbkey_so_name}" ]; then
		sudo rm -r -f /usr/lib/${usbkey_so_name}
	fi

	if [ -e	 "/usr/lib/${usbkey_so_name}" ]; then
		echo "UKEY's lib uninstall error"
	else 
		echo "UKEY's lib uninstall OK"
	fi

	if [ -e	 "/etc/udev/rules.d/${usbkey_rules_name}" ]; then
		sudo rm -r -f /etc/udev/rules.d/${usbkey_rules_name}
	fi

	if [ -e	 "/etc/udev/rules.d/${usbkey_rules_name}" ]; then
		echo "UKEY's rudes uninstall error"
	else 
		echo "UKEY's rudes uninstall OK"
	fi

}

function uninstall_FriDriverUI()
{
	
	if [ -e	 "${install_to_path}/${FriDriverUI_path}" ]; then	
		cd ${install_to_path}/${FriDriverUI_path}
		./uninstall.sh
	fi
	
	sudo rm -r -f /usr/share/applications/usbkeytool.desktop
	sudo rm -r -f $HOME/Desktop/usbkeytool.desktop

	sudo rm -r -f /usr/share/applications/admintool.desktop
	sudo rm -r -f $HOME/Desktop/admintool.desktop

	sudo rm -r -f /usr/share/applications/KeyProxy.desktop
	sudo rm -r -f $HOME/Desktop/KeyProxy.desktop
	
}

function uninstall_OtherSoftware()
{
	if [ -d "${install_to_path}" ]; then
		cd ${install_to_path}
		cd ../
        	sudo rm -rf usbkey/
		
    	fi

	if [ ! -d "${install_to_path}" ]; then
		echo "UKEY's other files uninstall OK"
	fi
}

#
function install_usbkeytool()
{
	cd ${install_to_path}
	if [ -d "${usbkey_tool_path}" ]; then	
		sudo rm -r -f ${install_to_path}/${usbkey_tool_path}
	fi
	sudo mkdir ${usbkey_tool_path}
	sudo chmod -R 777 ${usbkey_tool_path}
	sudo cp ${shell_path}/${usbkey_tool_path}/${usbkey_tool_name} ${usbkey_tool_path}
	sudo chmod +x ${usbkey_tool_path}/${usbkey_tool_name}
	sudo cp ${shell_path}/${usbkey_tool_path}/usbkeytool.sh ${usbkey_tool_path}
	sudo chmod +x ${usbkey_tool_path}/usbkeytool.sh

	#ƿݷʽӦݷʽĿ¼Լݷʽ
	sudo cp ${shell_path}/${usbkey_tool_path}/usbkeytool.desktop ${usbkey_tool_path}
	sudo cp ${shell_path}/${usbkey_tool_path}/usbkeytool.png ${usbkey_tool_path}
	
	sudo cp ${usbkey_tool_path}/usbkeytool.desktop /usr/share/applications
	sudo cp ${usbkey_tool_path}/usbkeytool.desktop $HOME/Desktop

	echo "UKEY's usbkeytool install OK"
	cd ${shell_path}
}

#
function install_admintool()
{
	cd ${install_to_path}
	if [ -d "${admin_tool_path}" ]; then	
		sudo rm -r -f ${install_to_path}/${admin_tool_path}
	fi
	sudo mkdir ${admin_tool_path}
	sudo chmod -R 777 ${admin_tool_path}
	sudo cp ${shell_path}/${admin_tool_path}/${admin_tool_name} ${admin_tool_path}
	sudo chmod +x ${admin_tool_path}/${admin_tool_name}
	
	#ƿݷʽӦݷʽĿ¼Լݷʽ
	sudo cp ${shell_path}/${admin_tool_path}/admintool.desktop ${admin_tool_path}
	sudo cp ${shell_path}/${admin_tool_path}/admintool.png ${admin_tool_path}
	sudo cp ${admin_tool_path}/admintool.desktop /usr/share/applications
	sudo cp ${admin_tool_path}/admintool.desktop $HOME/Desktop

	echo "UKEY's admintool install OK"
	cd ${shell_path}
}

#
function install_keyproxy()
{
	cd ${install_to_path}
	if [ -d "${keyproxy_path}" ]; then	
		sudo rm -r -f ${install_to_path}/${keyproxy_path}
	fi
	sudo mkdir ${keyproxy_path}
	sudo chmod -R 777 ${keyproxy_path}
	sudo cp -R ${shell_path}/${keyproxy_path}/* ${keyproxy_path}/
	sudo chmod +x ${keyproxy_path}/${keyproxy_name}	

	#ƿݷʽӦݷʽĿ¼Լݷʽ
	#sudo cp ${shell_path}/${keyproxy_path}/KeyProxy.desktop ${keyproxy_path}
	#sudo cp ${shell_path}/${keyproxy_path}/KeyProxy.png ${keyproxy_path}
	#sudo cp ${keyproxy_path}/KeyProxy.desktop /usr/share/applications
	#sudo cp ${keyproxy_path}/KeyProxy.desktop $HOME/Desktop

	echo "UKEY's keyproxy install OK"
	cd ${shell_path}
}

function install_FriDriverUI()
{
	cd ${install_to_path}
	if [ -d "${FriDriverUI_path}" ]; then	
		sudo rm -r -f ${install_to_path}/${FriDriverUI_path}
	fi
	sudo mkdir ${FriDriverUI_path}
	sudo chmod -R 777 ${FriDriverUI_path}
	sudo cp -R ${shell_path}/${FriDriverUI_path}/* ${FriDriverUI_path}/

	cd ${install_to_path}/${FriDriverUI_path}
	./install.sh
	
	echo "UKEY's FriDriverUI install OK"
	cd ${shell_path}
}

function checkInstallPath()
{
	if [ ! -d "${install_to_path}" ]; then	
        	sudo mkdir -p ${install_to_path}
    	fi
}


param=$1
function main()
{
	if [ "${param}" == '' ] ; then
		echo "need operation param!!!"
		echo "if you want to install,please run './install.sh install' "
		echo "if you want to uninstall,please run './install.sh uninstall' "
		echo "thank you for your cooperation ^ ^ !"
	fi
	if [ "${param}" == 'install' ] ; then
		echo '----------start install ------------'
		checkInstallPath
		install_uk_so
		install_usbkeytool
		#install_admintool
		install_keyproxy
		install_FriDriverUI
		echo '----------istall success  ----------'
	fi
	if [ "${param}" == 'uninstall' ] ; then
		echo '----------start uninstall ----------'
		uninstall_uk_so
		uninstall_FriDriverUI
		uninstall_OtherSoftware
		echo '----------uninstall success  -------'
	fi
}

main


